<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.10.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>MeLOn: C:/Data/Git/MeLOn/common/inc/vectorarithmetics.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<script type="text/javascript" src="clipboard.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript" src="cookie.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="MeLOn_only.png"/></td>
  <td id="projectalign">
   <div id="projectname">MeLOn
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.10.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() { codefold.init(0); });
/* @license-end */
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function(){initNavTree('vectorarithmetics_8h_source.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">vectorarithmetics.h</div></div>
</div><!--header-->
<div class="contents">
<a href="vectorarithmetics_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**********************************************************************************</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment">* Copyright (c) 2020 Process Systems Engineering (AVT.SVT), RWTH Aachen University</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment">*</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment">* This program and the accompanying materials are made available under the</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment">* terms of the Eclipse Public License 2.0 which is available at</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment">* http://www.eclipse.org/legal/epl-2.0.</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment">*</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment">* SPDX-License-Identifier: EPL-2.0</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment">*</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment">* @file vectorarithmetics.h</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment">* @brief File containing overloaded vector functions for performing linear algebra operations.</span></div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">*</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment">**********************************************************************************/</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span> </div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span> </div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span><span class="preprocessor">#include &lt;vector&gt;</span>       <span class="comment">// std::vector</span></div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span><span class="preprocessor">#include &lt;numeric&gt;</span>      <span class="comment">// std::inner_product</span></div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno">   20</span><span class="preprocessor">#include &lt;algorithm&gt;</span>    <span class="comment">// std::transform</span></div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span><span class="preprocessor">#include &lt;cassert&gt;</span>      <span class="comment">// std::assert</span></div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacemelon.html">melon</a> {</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00034" data-start="{" data-end="}">
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno"><a class="line" href="namespacemelon.html#a80e855bf708cd67182f551d005dea25e">   34</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a80e855bf708cd67182f551d005dea25e">operator+</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v1, <span class="keyword">const</span> std::vector&lt;U&gt; &amp;v2) {</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>        assert(v1.size() == v2.size());</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) + U(1))&gt; result;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        result.reserve(v1.size());</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span>        std::transform(std::begin(v1), std::end(v1), std::begin(v2), std::back_inserter(result), [](T i, U j) { <span class="keywordflow">return</span> i + j; });</div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    };</div>
</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00052" data-start="{" data-end="}">
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno"><a class="line" href="namespacemelon.html#ab2653a81de37c679fc48d8303b202614">   52</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a80e855bf708cd67182f551d005dea25e">operator+</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v, <span class="keyword">const</span> U s) {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) + U(1))&gt; result;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        std::transform(std::begin(v), std::end(v), std::back_inserter(result), [s](T i) {<span class="keywordflow">return</span> i + s; });</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    }</div>
</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00069" data-start="{" data-end="}">
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno"><a class="line" href="namespacemelon.html#a2b23af0670582490d233e2cfa02bbf7a">   69</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a2b23af0670582490d233e2cfa02bbf7a">operator-</a>(std::vector&lt;T&gt; &amp;v1, std::vector&lt;U&gt; &amp;v2) {</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        assert(v1.size() == v2.size());</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span>        std::vector&lt;<span class="keyword">decltype</span>(v1.at(0) - v2.at(0))&gt; result;</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        result.reserve(v1.size());</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        std::transform(std::begin(v1), std::end(v1), std::begin(v2), std::back_inserter(result), [](T i, U j) { <span class="keywordflow">return</span> i - j; });</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>    };</div>
</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span> </div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00087" data-start="{" data-end="}">
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno"><a class="line" href="namespacemelon.html#a7bdd489b771e3b35186e3a89fc4520ad">   87</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a2b23af0670582490d233e2cfa02bbf7a">operator-</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v, <span class="keyword">const</span> U s) {</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) - U(1))&gt; result;</div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        std::transform(std::begin(v), std::end(v), std::back_inserter(result), [s](T i) {<span class="keywordflow">return</span> i - s; });</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>    }</div>
</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00104" data-start="{" data-end="}">
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno"><a class="line" href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">  104</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">operator*</a>(<span class="keyword">const</span> T &amp;s, <span class="keyword">const</span> std::vector&lt;U&gt; &amp;v) {</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) * U(1))&gt; result;</div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>        std::transform(std::begin(v), std::end(v), std::back_inserter(result), [s](U i) {<span class="keywordflow">return</span> i * s; });</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>    }</div>
</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span> </div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00121" data-start="{" data-end="}">
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno"><a class="line" href="namespacemelon.html#aae6d2a726febc6962b2b4b60fe1bb472">  121</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">operator*</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v, <span class="keyword">const</span> U &amp;s) {</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) * U(1))&gt; result;</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>        std::transform(std::begin(v), std::end(v), std::back_inserter(result), [s](T i) {<span class="keywordflow">return</span> i * s; });</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    }</div>
</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span> </div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00138" data-start="{" data-end="}">
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno"><a class="line" href="namespacemelon.html#a24bae557d935851e04ec91570cdf6b46">  138</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a24bae557d935851e04ec91570cdf6b46">operator/</a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v, <span class="keyword">const</span> U&amp; s) {</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1) / U(1))&gt; result;</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno">  141</span>        std::transform(std::begin(v), std::end(v), std::back_inserter(result), [s](T i) {<span class="keywordflow">return</span> i / s; });</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>    }</div>
</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00155" data-start="{" data-end="}">
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno"><a class="line" href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">  155</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">dot_product</a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v1, <span class="keyword">const</span> std::vector&lt;U&gt; &amp;v2) {</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        assert(v1.size() == v2.size());</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span> </div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        <span class="keywordflow">return</span> std::inner_product(std::begin(v1), std::end(v1), std::begin(v2), T(0)*U(0));</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>    }</div>
</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span> </div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00171" data-start="{" data-end="}">
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno"><a class="line" href="namespacemelon.html#adfc1c64d377bc9a21eea10b08a2812bd">  171</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">operator*</a>(<span class="keyword">const</span> std::vector&lt;std::vector&lt;T&gt;&gt; &amp;m, <span class="keyword">const</span> std::vector&lt;U&gt; &amp;v) {</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        std::vector&lt;<span class="keyword">decltype</span>(T(1)*U(1))&gt; result;</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>        result.reserve(v.size());</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>        std::transform(std::begin(m), std::end(m), std::back_inserter(result), [v](std::vector&lt;T&gt; m_i) {<span class="keywordflow">return</span> <a class="code hl_function" href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">dot_product</a>(m_i, v); });</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span> </div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>    }</div>
</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span> </div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T, <span class="keyword">typename</span> U&gt;</div>
<div class="foldopen" id="foldopen00189" data-start="{" data-end="}">
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno"><a class="line" href="namespacemelon.html#a40328bd6fab65711cf52ef704a727e63">  189</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">operator*</a>(<span class="keyword">const</span> std::vector&lt;std::vector&lt;T&gt;&gt; &amp;m1, <span class="keyword">const</span> std::vector&lt;std::vector&lt;U&gt;&gt; &amp;m2) {</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>        assert(m1.at(0).size() == m2.size());</div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        std::vector&lt;std::vector&lt;<span class="keyword">decltype</span>(T(1) * U(1))&gt;&gt; result;</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>        result.reserve(m1.size());</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        std::transform(std::begin(m2), std::end(m2), std::back_inserter(result), [m1](std::vector&lt;U&gt; m_i) {<span class="keywordflow">return</span> m1 * m_i; });</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span> </div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>    }</div>
</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span> </div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00206" data-start="{" data-end="}">
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno"><a class="line" href="namespacemelon.html#aa014086872bff2237b6ffa78096b593f">  206</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#aa014086872bff2237b6ffa78096b593f">transpose</a>(<span class="keyword">const</span> std::vector&lt;std::vector&lt;T&gt;&gt; &amp;m) {</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        std::vector&lt;std::vector&lt;T&gt;&gt; result(m.at(0).size(), std::vector&lt;T&gt;(m.size()));</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        <span class="keywordflow">for</span> (std::vector&lt;int&gt;::size_type i = 0; i &lt; m.size(); i++) {</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>            <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> j = 0; j &lt; m[0].size(); j++) {</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>                result.at(j).at(i) = m.at(i).at(j);</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>            }</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>        }</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>    }</div>
</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span> </div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;</div>
<div class="foldopen" id="foldopen00224" data-start="{" data-end="}">
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno"><a class="line" href="namespacemelon.html#a16df369db8ed77a096d88bcac6c37487">  224</a></span>    <span class="keyword">auto</span> <a class="code hl_function" href="namespacemelon.html#a16df369db8ed77a096d88bcac6c37487">diag</a>(<span class="keyword">const</span> std::vector&lt;std::vector&lt;T&gt;&gt; &amp;m) {</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        assert(m.size() == m.at(0).size());</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>        std::vector&lt;T&gt; result;</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>        <span class="keywordflow">for</span> (<span class="keywordtype">size_t</span> i = 0; i &lt; m.size(); i++)</div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        {</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>            result.push_back(m.at(i).at(i));</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>        }</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span>        <span class="keywordflow">return</span> result;</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>    }</div>
</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>}</div>
<div class="ttc" id="anamespacemelon_html"><div class="ttname"><a href="namespacemelon.html">melon</a></div><div class="ttdef"><b>Definition</b> kernel.h:21</div></div>
<div class="ttc" id="anamespacemelon_html_a01c6cf5e8fc7f903c966ed77d3582789"><div class="ttname"><a href="namespacemelon.html#a01c6cf5e8fc7f903c966ed77d3582789">melon::operator*</a></div><div class="ttdeci">auto operator*(const T &amp;s, const std::vector&lt; U &gt; &amp;v)</div><div class="ttdoc">Overloaded operator for vector class allowing the calulation of a vector scalar product.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:104</div></div>
<div class="ttc" id="anamespacemelon_html_a16df369db8ed77a096d88bcac6c37487"><div class="ttname"><a href="namespacemelon.html#a16df369db8ed77a096d88bcac6c37487">melon::diag</a></div><div class="ttdeci">auto diag(const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m)</div><div class="ttdoc">Overloaded operator for vector class allowing to obtain a matrix diagonal.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:224</div></div>
<div class="ttc" id="anamespacemelon_html_a24bae557d935851e04ec91570cdf6b46"><div class="ttname"><a href="namespacemelon.html#a24bae557d935851e04ec91570cdf6b46">melon::operator/</a></div><div class="ttdeci">auto operator/(const std::vector&lt; T &gt; &amp;v, const U &amp;s)</div><div class="ttdoc">Overloaded operator for vector class allowing the calulation of a vector scalar division.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:138</div></div>
<div class="ttc" id="anamespacemelon_html_a2b23af0670582490d233e2cfa02bbf7a"><div class="ttname"><a href="namespacemelon.html#a2b23af0670582490d233e2cfa02bbf7a">melon::operator-</a></div><div class="ttdeci">auto operator-(std::vector&lt; T &gt; &amp;v1, std::vector&lt; U &gt; &amp;v2)</div><div class="ttdoc">Overloaded operator for vector class allowing substracting vectors.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:69</div></div>
<div class="ttc" id="anamespacemelon_html_a80e855bf708cd67182f551d005dea25e"><div class="ttname"><a href="namespacemelon.html#a80e855bf708cd67182f551d005dea25e">melon::operator+</a></div><div class="ttdeci">auto operator+(const std::vector&lt; T &gt; &amp;v1, const std::vector&lt; U &gt; &amp;v2)</div><div class="ttdoc">Overloaded operator for vector class allowing adding vectors.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:34</div></div>
<div class="ttc" id="anamespacemelon_html_a9cb84438576c7ac32cbe6f10b3e9e2b3"><div class="ttname"><a href="namespacemelon.html#a9cb84438576c7ac32cbe6f10b3e9e2b3">melon::dot_product</a></div><div class="ttdeci">auto dot_product(const std::vector&lt; T &gt; &amp;v1, const std::vector&lt; U &gt; &amp;v2)</div><div class="ttdoc">Overloaded operator for vector class allowing the calulation of dot product of two vectors.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:155</div></div>
<div class="ttc" id="anamespacemelon_html_aa014086872bff2237b6ffa78096b593f"><div class="ttname"><a href="namespacemelon.html#aa014086872bff2237b6ffa78096b593f">melon::transpose</a></div><div class="ttdeci">auto transpose(const std::vector&lt; std::vector&lt; T &gt; &gt; &amp;m)</div><div class="ttdoc">Overloaded operator for vector class allowing to transpose a matrix.</div><div class="ttdef"><b>Definition</b> vectorarithmetics.h:206</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bdd9a5d540de89e9fe90efdfc6973a4f.html">common</a></li><li class="navelem"><a class="el" href="dir_a065f42410ce59d310ee6ca453a28844.html">inc</a></li><li class="navelem"><a class="el" href="vectorarithmetics_8h.html">vectorarithmetics.h</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.10.0 </li>
  </ul>
</div>
</body>
</html>
